diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index e04c60072..d1fe54ece 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -7,169 +7,320 @@ import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.Map;
 
-public class EntityDispatcher
+public final class EntityDispatcher
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-    public static final Map<String, Class<? extends Entity>> keyToClassMap = new HashMap<>();
-    public static final Map<Class<? extends Entity>, String> classToKeyMap = new HashMap<>();
-    private static final Map<Integer, Class<? extends Entity>> idToClassMap = new HashMap<>();
-    private static final Map<Class<? extends Entity>, Integer> classToIdMap = new HashMap<>();
+    private static int mappingCount = 0;
 
-    private static int maxIdSize = 0;
+    public static final Map<Class<? extends Entity>, NamespaceID> classToIdMap = new HashMap<>();
+    public static final Map<NamespaceID, Class<? extends Entity>> idToClassMap = new HashMap<>();
+    public static final Map<String, Class<? extends Entity>> stringIdToClassMap = new HashMap<>();
 
-    public EntityDispatcher()
-    {
+    private static final Map<Integer, Class<? extends Entity>> numericIdToClassMap = new HashMap<>();
+    private static final Map<Integer, String> numericIdToStringIdMap = new HashMap<>();
+    private static final Map<Class<? extends Entity>, Integer> classToNumericIdMap = new HashMap<>();
+
+    private static final Map<Class<? extends Entity>, String> classToNameKeyMap = new HashMap<>();
+
+    private EntityDispatcher() {}
+
+    public static void addMapping(@NotNull Class<? extends Entity> entityClass, @NotNull NamespaceID namespaceID) {
+        addMapping(entityClass, namespaceID, null);
     }
 
-    public static void addMapping(Class<? extends Entity> clazz, String key, int id)
-    {
-        keyToClassMap.put(key, clazz);
-        classToKeyMap.put(clazz, key);
-        idToClassMap.put(id, clazz);
-        classToIdMap.put(clazz, id);
+    public static void addMapping(@NotNull Class<? extends Entity> entityClass, @NotNull NamespaceID namespaceID, @Nullable String nameKey) {
+        if (classToIdMap.containsKey(entityClass)) {
+            throw new IllegalArgumentException("EntityDispatcher already contains an assignment for class " + entityClass.getSimpleName() + " with namespace " + classToIdMap.get(entityClass) + "!");
+        }
+
+        classToIdMap.put(entityClass, namespaceID);
+        idToClassMap.put(namespaceID, entityClass);
+        stringIdToClassMap.put(namespaceID.toString(), entityClass);
 
-        if (key.length() > maxIdSize) {
-            maxIdSize = key.length();
+        int numericId = mappingCount++;
+        numericIdToClassMap.put(numericId, entityClass);
+        numericIdToStringIdMap.put(numericId, namespaceID.toString());
+        classToNumericIdMap.put(entityClass, numericId);
+
+        if (nameKey != null) {
+            classToNameKeyMap.put(entityClass, nameKey);
         }
     }
 
-    public static Entity createEntityInWorld(String id, World world)
+    public static @Nullable Class<? extends Entity> classForId(NamespaceID id) {
+        return idToClassMap.get(id);
+    }
+
+    public static @Nullable Class<? extends Entity> classForId(String id) {
+        return stringIdToClassMap.get(id);
+    }
+
+    public static @Nullable NamespaceID idForClass(Class<? extends Entity> entityClass) {
+        return classToIdMap.get(entityClass);
+    }
+
+    public static @Nullable Class<? extends Entity> classForNumericId(int id) {
+        return numericIdToClassMap.get(id);
+    }
+
+    public static @Nullable String nameKeyForClass(Class<? extends Entity> entityClass) {
+        return classToNameKeyMap.get(entityClass);
+    }
+
+    public static int numericIdForClass(Class<? extends Entity> entityClass) {
+        return classToNumericIdMap.getOrDefault(entityClass, -1);
+    }
+
+    public static void setNumericIds(Map<Integer, String> mapping) {
+        numericIdToClassMap.clear();
+        numericIdToStringIdMap.clear();
+        classToNumericIdMap.clear();
+        for (Map.Entry<Integer, String> entry : mapping.entrySet()) {
+            Class<? extends Entity> entityClass = classForId(entry.getValue());
+            if (entityClass == null) {
+                LOGGER.error("Could not find entityClass assigned to namespace id {}! Skipping!", entry.getValue());
+                continue;
+            }
+
+            numericIdToClassMap.put(entry.getKey(), entityClass);
+            numericIdToStringIdMap.put(entry.getKey(), entry.getValue());
+            classToNumericIdMap.put(entityClass, entry.getKey());
+
+            if (entry.getKey() >= mappingCount) {
+                mappingCount = entry.getKey() + 1;
+            }
+        }
+    }
+
+    public static Map<Integer, String> getEntityIds() {
+        return numericIdToStringIdMap;
+    }
+
+    public static @Nullable Entity createEntityInWorld(String id, World world)
     {
+        if (id == null) return null;
+        if (Legacy.isLegacyKey(id)) { // Handle entity creation via legacy id
+            return createEntityInWorld(Legacy.getClassFromEncodeID(id), world);
+        } else {
+            Class<? extends Entity> entityClass = classForId(id);
+            if (entityClass == null) {
+                LOGGER.warn("EntityDispatcher could not find entity class for id '{}'!", id);
+                return null;
+            }
+            return createEntityInWorld(entityClass, world);
+        }
+    }
+
+    public static @Nullable Entity createEntityInWorld(NamespaceID id, World world) {
+        return createEntityInWorld(classForId(id), world);
+    }
+
+    public static @Nullable Entity createEntityInWorld(Class<? extends Entity> clazz, World world) {
         Entity entity = null;
-        try
-        {
-            Class<? extends Entity> clazz = keyToClassMap.get(id);
-            if(clazz != null)
-            {
+        try {
+            if(clazz != null) {
                 entity = clazz.getConstructor(World.class).newInstance(world);
+            } else {
+                return null;
             }
         }
-        catch(Exception exception)
-        {
-            LOGGER.error("Failed to instance entity id '{}'!", id, exception);
+        catch(Exception exception) {
+            LOGGER.error("Failed to instance for class '{}'!", clazz.getSimpleName(), exception);
         }
         return entity;
     }
 
     public static Entity createEntityFromNBT(CompoundTag compoundTag, World world)
     {
-        Entity entity = null;
-        try
-        {
-            Class<? extends Entity> clazz = keyToClassMap.get(compoundTag.getString("id"));
-            if(clazz != null)
-            {
-                entity = clazz.getConstructor(new Class[] {World.class}).newInstance(world);
-            }
-        }
-        catch(Exception exception)
-        {
-            LOGGER.error("Failed to instance entity id '{}'!", compoundTag.getStringOrDefault("id", "UNKNOWN"), exception);
-        }
-        if(entity != null)
-        {
+        String id = compoundTag.getStringOrDefault("id", "UNKNOWN");
+        Entity entity = createEntityInWorld(id, world);
+
+        if(entity != null) {
             entity.load(compoundTag);
-        } else
-        {
+        } else {
             LOGGER.warn("Skipping Entity with id {}", compoundTag.getStringOrDefault("id", "UNKNOWN"));
         }
         return entity;
     }
 
-    public static Entity createEntity(int id, World world)
+    public static @Nullable Entity createEntity(int id, World world)
     {
-        Entity entity = null;
+        @Nullable Entity entity = null;
         try
         {
-            Class<? extends Entity> clazz = idToClassMap.get(id);
+            Class<? extends Entity> clazz = classForNumericId(id);
             if(clazz != null) {
                 entity = clazz.getConstructor(new Class[] {World.class}).newInstance(world);
+            } else {
+                LOGGER.error("No entity class assign to id {}!", id);
             }
         }
         catch(Exception exception)
         {
             LOGGER.error("Failed to instance entity id '{}'!", id, exception);
         }
-        if(entity == null)
-        {
-            LOGGER.warn("Skipping Entity with id {}", id);
-        }
         return entity;
     }
 
-    public static int getEntityID(Entity entity)
-    {
-        return getEntityID(entity.getClass());
-    }
+    private static boolean hasInit = false;
+    public static void init() {
+        if (hasInit) return;
+        hasInit = true;
 
-    public static int getEntityID(Class<? extends Entity> entityClass) {
-        return classToIdMap.get(entityClass);
-    }
+        // Misc
+        addMapping(EntityItem.class, new NamespaceID("minecraft", "item"));
+        addMapping(EntityPainting.class, new NamespaceID("minecraft", "painting"));
+        addMapping(EntityLightning.class, new NamespaceID("minecraft", "lightning"));
+        addMapping(EntityFallingBlock.class, new NamespaceID("minecraft", "falling_block"));
+        addMapping(MinecartEntity.class, new NamespaceID("minecraft", "minecart"));
+        addMapping(EntityBoat.class, new NamespaceID("minecraft", "boat"));
+        addMapping(EntityPrimedTNT.class, new NamespaceID("minecraft", "primed_tnt"));
 
-    public static String getEncodeId(Entity entity)
-    {
-        return classToKeyMap.get(entity.getClass());
-    }
+        // Projectiles
+        addMapping(ProjectilePebble.class, new NamespaceID("minecraft", "pebble"));
+        addMapping(ProjectileArrow.class, new NamespaceID("minecraft", "arrow"));
+        addMapping(ProjectileArrowGolden.class, new NamespaceID("minecraft", "arrow_golden"));
+        addMapping(ProjectileArrowPurple.class, new NamespaceID("minecraft", "arrow_purple"));
+        addMapping(ProjectileSnowball.class, new NamespaceID("minecraft", "snowball"));
+        addMapping(ProjectileFireball.class, new NamespaceID("minecraft", "fireball"));
+        addMapping(ProjectileCannonball.class, new NamespaceID("minecraft", "cannonball"));
 
-    public static String getEncodeId(Class<? extends Entity> clazz)
-    {
-        return classToKeyMap.get(clazz);
-    }
+//        addMapping(Mob.class, new NamespaceID("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
+        addMapping(MobHuman.class, new NamespaceID("minecraft", "human"));
 
-    public static Class<? extends Entity> getClassFromID(int id) {
-        return idToClassMap.get(id);
-    }
+        // Hostile
+        addMapping(MobZombie.class, new NamespaceID("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
+        addMapping(MobZombieArmored.class, new NamespaceID("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
+        addMapping(MobZombiePig.class, new NamespaceID("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
+        addMapping(MobCreeper.class, new NamespaceID("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
+        addMapping(MobSkeleton.class, new NamespaceID("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
+        addMapping(MobSpider.class, new NamespaceID("minecraft", "spider"), "guidebook.section.mob.spider.name");
+        addMapping(MobGiant.class, new NamespaceID("minecraft", "giant"));
+        addMapping(MobSlime.class, new NamespaceID("minecraft", "slime"), "guidebook.section.mob.slime.name");
+        addMapping(MobGhast.class, new NamespaceID("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
+        addMapping(MobSnowman.class, new NamespaceID("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
 
-    public static Class<? extends Entity> getClassFromEncodeID(String encodeID) {
-        return keyToClassMap.get(encodeID);
+        // Passive
+        addMapping(MobScorpion.class, new NamespaceID("minecraft", "scorpion"));
+        addMapping(MobPig.class, new NamespaceID("minecraft", "pig"), "guidebook.section.mob.pig.name");
+        addMapping(MobSheep.class, new NamespaceID("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
+        addMapping(MobCow.class, new NamespaceID("minecraft", "cow"), "guidebook.section.mob.cow.name");
+        addMapping(MobChicken.class, new NamespaceID("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
+        addMapping(MobSquid.class, new NamespaceID("minecraft", "squid"), "guidebook.section.mob.squid.name");
+        addMapping(MobWolf.class, new NamespaceID("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
+        addMapping(MobFireflyCluster.class, new NamespaceID("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
     }
 
-    public static int getLargestIdSize() {
-        return maxIdSize;
-    }
+    @Deprecated
+    public static class Legacy {
+        public static final Map<String, Class<? extends Entity>> keyToClassMap = new HashMap<>();
+        public static final Map<Class<? extends Entity>, String> classToKeyMap = new HashMap<>();
+        private static final Map<Integer, Class<? extends Entity>> idToClassMap = new HashMap<>();
+        private static final Map<Class<? extends Entity>, Integer> classToIdMap = new HashMap<>();
 
-    static 
-    {
-        addMapping(EntityItem.class, "Item", 1);
-        addMapping(EntityLightning.class, "Lightning", 8);
-        addMapping(EntityPainting.class, "Painting", 9);
-        addMapping(ProjectileArrow.class, "Arrow", 10);
-        addMapping(ProjectileSnowball.class, "Snowball", 11);
-        addMapping(ProjectileFireball.class, "Fireball", 12);
-        addMapping(EntityPrimedTNT.class, "PrimedTnt", 20);
-        addMapping(EntityFallingBlock.class, "FallingSand", 21);
-        addMapping(MinecartEntity.class, "Minecart", 40);
-        addMapping(EntityBoat.class, "Boat", 41);
-        addMapping(MobZombieArmored.class, "ArmouredZombie", 42);
-        addMapping(ProjectileArrowGolden.class, "ArrowGolden", 43);
-        addMapping(ProjectileCannonball.class, "Cannonball", 44);
-        addMapping(ProjectileArrowPurple.class, "ArrowPurple", 45);
-        addMapping(ProjectilePebble.class, "Pebble", 46);
-        addMapping(MobFireflyCluster.class, "FireflyCluster", 47);
-        addMapping(Mob.class, "Mob", 48);
-        addMapping(MobHuman.class, "MobMonster", 49);
-        addMapping(MobCreeper.class, "Creeper", 50);
-        addMapping(MobSkeleton.class, "Skeleton", 51);
-        addMapping(MobSpider.class, "Spider", 52);
-        addMapping(MobGiant.class, "Giant", 53);
-        addMapping(MobZombie.class, "Zombie", 54);
-        addMapping(MobSlime.class, "Slime", 55);
-        addMapping(MobGhast.class, "Ghast", 56);
-        addMapping(MobZombiePig.class, "PigZombie", 57);
-        addMapping(MobSnowman.class, "Snowman", 58);
-        addMapping(MobScorpion.class, "Scorpion", 59);
-        addMapping(MobPig.class, "Pig", 90);
-        addMapping(MobSheep.class, "Sheep", 91);
-        addMapping(MobCow.class, "Cow", 92);
-        addMapping(MobChicken.class, "Chicken", 93);
-        addMapping(MobSquid.class, "Squid", 94);
-        addMapping(MobWolf.class, "Wolf", 95);
+        private static int maxIdSize = 0;
+
+        @Deprecated
+        public static void addMapping(Class<? extends Entity> clazz, String key, int id)
+        {
+            keyToClassMap.put(key, clazz);
+            classToKeyMap.put(clazz, key);
+            idToClassMap.put(id, clazz);
+            classToIdMap.put(clazz, id);
+
+            if (key.length() > maxIdSize) {
+                maxIdSize = key.length();
+            }
+        }
+
+        @Deprecated
+        public static int getEntityID(Entity entity)
+        {
+            return getEntityID(entity.getClass());
+        }
+
+        @Deprecated
+        public static int getEntityID(Class<? extends Entity> entityClass) {
+            return classToIdMap.get(entityClass);
+        }
+
+        @Deprecated
+        public static String getEncodeId(Entity entity)
+        {
+            return classToKeyMap.get(entity.getClass());
+        }
+
+        @Deprecated
+        public static String getEncodeId(Class<? extends Entity> clazz)
+        {
+            return classToKeyMap.get(clazz);
+        }
+
+        @Deprecated
+        public static Class<? extends Entity> getClassFromID(int id) {
+            return idToClassMap.get(id);
+        }
+
+        @Deprecated
+        public static Class<? extends Entity> getClassFromEncodeID(String encodeID) {
+            return keyToClassMap.get(encodeID);
+        }
+
+        @Deprecated
+        public static int getLargestIdSize() {
+            return maxIdSize;
+        }
+
+        public static boolean isLegacyKey(String key) {
+            return keyToClassMap.containsKey(key);
+        }
+
+        static
+        {
+            addMapping(EntityItem.class, "Item", 1);
+            addMapping(EntityLightning.class, "Lightning", 8);
+            addMapping(EntityPainting.class, "Painting", 9);
+            addMapping(ProjectileArrow.class, "Arrow", 10);
+            addMapping(ProjectileSnowball.class, "Snowball", 11);
+            addMapping(ProjectileFireball.class, "Fireball", 12);
+            addMapping(EntityPrimedTNT.class, "PrimedTnt", 20);
+            addMapping(EntityFallingBlock.class, "FallingSand", 21);
+            addMapping(MinecartEntity.class, "Minecart", 40);
+            addMapping(EntityBoat.class, "Boat", 41);
+            addMapping(MobZombieArmored.class, "ArmouredZombie", 42);
+            addMapping(ProjectileArrowGolden.class, "ArrowGolden", 43);
+            addMapping(ProjectileCannonball.class, "Cannonball", 44);
+            addMapping(ProjectileArrowPurple.class, "ArrowPurple", 45);
+            addMapping(ProjectilePebble.class, "Pebble", 46);
+            addMapping(MobFireflyCluster.class, "FireflyCluster", 47);
+            addMapping(Mob.class, "Mob", 48);
+            addMapping(MobHuman.class, "MobMonster", 49);
+            addMapping(MobCreeper.class, "Creeper", 50);
+            addMapping(MobSkeleton.class, "Skeleton", 51);
+            addMapping(MobSpider.class, "Spider", 52);
+            addMapping(MobGiant.class, "Giant", 53);
+            addMapping(MobZombie.class, "Zombie", 54);
+            addMapping(MobSlime.class, "Slime", 55);
+            addMapping(MobGhast.class, "Ghast", 56);
+            addMapping(MobZombiePig.class, "PigZombie", 57);
+            addMapping(MobSnowman.class, "Snowman", 58);
+            addMapping(MobScorpion.class, "Scorpion", 59);
+            addMapping(MobPig.class, "Pig", 90);
+            addMapping(MobSheep.class, "Sheep", 91);
+            addMapping(MobCow.class, "Cow", 92);
+            addMapping(MobChicken.class, "Chicken", 93);
+            addMapping(MobSquid.class, "Squid", 94);
+            addMapping(MobWolf.class, "Wolf", 95);
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index de8ffe0e4..22a1a068d 100644
--- a/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, World, BlockSand,
-//            NBTTagCompound
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockSand;
 import net.minecraft.core.block.Blocks;
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/src/main/java/net/minecraft/core/entity/EntityItem.java
index 5cf1915b5..a48f94408 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -3,12 +3,6 @@ package net.minecraft.core.entity;
 import java.util.List;
 
 import com.mojang.nbt.CompoundTag;
-
-// Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, World, Material, 
-//            AxisAlignedBB, Block, NBTTagCompound, ItemStack, 
-//            Player, InventoryPlayer, Achievements, Item
-
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
diff --git a/src/main/java/net/minecraft/core/entity/EntityLightning.java b/src/main/java/net/minecraft/core/entity/EntityLightning.java
index 25360e394..7eb092cea 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -11,11 +11,6 @@ import net.minecraft.core.world.World;
 
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            EntityWeatherEffect, World, MathHelper, Block, 
-//            BlockFire, AxisAlignedBB, Entity, NBTTagCompound,
-//            Vec3D
-
 public class EntityLightning extends Entity
 {
     private int life;
diff --git a/src/main/java/net/minecraft/core/entity/EntityPainting.java b/src/main/java/net/minecraft/core/entity/EntityPainting.java
index f40331605..dd913e88f 100644
--- a/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -15,11 +15,6 @@ import net.minecraft.core.util.helper.DamageType;
 
 import java.util.*;
 
-// Referenced classes of package net.minecraft.src:
-//            Entity, ArtType, AxisAlignedBB, World,
-//            EntityItem, ItemStack, Item, MathHelper,
-//            Material, NBTTagCompound
-
 public class EntityPainting extends Entity
 {
     public static final int DATA_ITEM_ID = 16;
@@ -170,7 +165,7 @@ public class EntityPainting extends Entity
         int xSize = art.sizeX / 16;
         int ySize = art.sizeY / 16;
         int xPosition = this.blockX;
-        int yPosition = this.blockY;
+        int yPosition = MathHelper.floor(y - (double)((float)art.sizeY / 32F));
         int zPosition = this.blockZ;
         if(direction == 0)
         {
@@ -188,7 +183,6 @@ public class EntityPainting extends Entity
         {
             zPosition = MathHelper.floor(z - (double)((float)art.sizeX / 32F));
         }
-        yPosition = MathHelper.floor(y - (double)((float)art.sizeY / 32F));
         for(int dx = 0; dx < xSize; dx++)
         {
             for(int dy = 0; dy < ySize; dy++)
diff --git a/src/main/java/net/minecraft/core/entity/EntityPrimedTNT.java b/src/main/java/net/minecraft/core/entity/EntityPrimedTNT.java
index d0f85b1f5..9268ef57f 100644
--- a/src/main/java/net/minecraft/core/entity/EntityPrimedTNT.java
+++ b/src/main/java/net/minecraft/core/entity/EntityPrimedTNT.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Entity, MathHelper, World, NBTTagCompound
-
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index 1c500d5a9..eee37609e 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -31,11 +31,6 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-// Referenced classes of package net.minecraft.src:
-//            Entity, Vec3D, World, Material,
-//            MathHelper, Block, StepSound, AxisAlignedBB,
-//            NBTTagCompound, ItemStack, MovingObjectPosition
-
 public abstract class Mob extends Entity
 {
     public static final int DATA_VARIANT = 1;
@@ -1084,7 +1079,6 @@ public abstract class Mob extends Entity
     protected void updateAI()
     {
         entityAge++;
-        Player entityplayer = world.getClosestPlayerToEntity(this, -1D);
         tryToDespawn();
         moveStrafing = 0.0F;
         moveForward = 0.0F;
diff --git a/src/main/java/net/minecraft/core/entity/MobFlying.java b/src/main/java/net/minecraft/core/entity/MobFlying.java
index f17358ada..c5bec5d4a 100644
--- a/src/main/java/net/minecraft/core/entity/MobFlying.java
+++ b/src/main/java/net/minecraft/core/entity/MobFlying.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Mob, MathHelper, AxisAlignedBB, World,
-//            Block
-
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
diff --git a/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index 8c6987f04..3b10a9791 100644
--- a/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.entity;
 
-// Referenced classes of package net.minecraft.src:
-//            Mob, World, Entity, AxisAlignedBB,
-//            MathHelper, PathEntity, Vec3D
-
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java b/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
index 14486242a..cf444dc60 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity.animal;
 
-
-// Referenced classes of package net.minecraft.src:
-//            EntityCreature, World, Block, GrassBlock,
-//            MathHelper, AxisAlignedBB, NBTTagCompound
-
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.MobPathfinder;
 import net.minecraft.core.entity.player.Player;
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobCow.java b/src/main/java/net/minecraft/core/entity/animal/MobCow.java
index c002d5394..9bd83a11d 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobCow.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobCow.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity.animal;
 
-
-// Referenced classes of package net.minecraft.src:
-//            MobAnimal, Item, Player, InventoryPlayer,
-//            ItemStack, World, NBTTagCompound
-
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index d69980f50..3f0124453 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -1,11 +1,5 @@
 package net.minecraft.core.entity.animal;
 
-
-// Referenced classes of package net.minecraft.src:
-//            MobAnimal, DataWatcher, NBTTagCompound, World,
-//            Player, Item, MobZombiePig, Achievements,
-//            EntityLightning
-
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Block;
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobSquid.java b/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
index 94c5155a6..d7375d80d 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity.animal;
 
-// Referenced classes of package net.minecraft.src:
-//            EntityWaterMob, ItemStack, Item, AxisAlignedBB, 
-//            Material, World, MathHelper, NBTTagCompound, 
-//            Player
-
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -49,7 +44,6 @@ public class MobSquid extends MobWaterAnimal
         tx = 0.0F;
         ty = 0.0F;
         tz = 0.0F;
-        isInWater();
         textureIdentifier = new NamespaceID("minecraft", "squid");
         setSize(0.95F, 0.95F);
         tentacleSpeed = (1.0F / (random.nextFloat() + 1.0F)) * 0.2F;
@@ -128,7 +122,7 @@ public class MobSquid extends MobWaterAnimal
                     yd *= 0.98D;
                     zd = 0.0D;
                 }
-                xBodyRot += (double)(-90F - xBodyRot) * 0.02D;
+                xBodyRot += (-90F - xBodyRot) * 0.02F;
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java b/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
index 0e06804b0..274466abc 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
@@ -1,9 +1,5 @@
 package net.minecraft.core.entity.animal;
 
-
-// Referenced classes of package net.minecraft.src:
-//            EntityCreature, World, NBTTagCompound
-
 import net.minecraft.core.entity.MobPathfinder;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
diff --git a/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index aaebe0192..3bab971d1 100644
--- a/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -22,12 +22,6 @@ import net.minecraft.core.util.helper.DamageType;
 
 import java.util.*;
 
-// Referenced classes of package net.minecraft.src:
-//            MobAnimal, DataWatcher, NBTTagCompound, World,
-//            Player, MobSheep, AxisAlignedBB, Entity,
-//            InventoryPlayer, ItemStack, Item, ItemFood,
-//            MathHelper, ProjectileArrow, Mob
-
 public class MobWolf extends MobAnimal
 {
     public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
diff --git a/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 2ae0f5969..de9506e2d 100644
--- a/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -1,10 +1,5 @@
 package net.minecraft.core.entity.monster;
 
-// Referenced classes of package net.minecraft.src:
-//            MobFlying, IMob, DataWatcher, World,
-//            MathHelper, Entity, AxisAlignedBB, ProjectileFireball,
-//            Vec3D, Item
-
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
